/*
HP-Plugin 4.0
by Sir Drink a lot

Aufgabe:
----------------------
Zeigt die Health (und Armor) an, die Dein Gegner noch hat, nachdem er Dich besiegte.
Zustzlich kann noch angezeigt werden, welche Waffe er hatte und wieviel
Du ihm abgezogen hast.

Befehle:
----------------------
- admin_hp als Grundbefehl. help oder gar kein Eintrag zeigt einem alle Einstellung
nochmal an.

- admin_hp status 1/0-->turns HP-Plugin on/off
- admin_hp armor 1/0-->turns display of armor on/off
- admin_hp death 1/0-->0=only shows HP in chat by typing hp/?hp/hp?,1=shows HP directly after death
- admin_hp display 1/2/0-->0=display in chat-area,1=display as tsay,2=display as csay
- admin_hp udo 1/0-->turns display of damage on/off, which you add to your enemy
- admin_hp weapon 1/0-->turns display of weapon on/off

(standard) Vault.ini Eintrge:
-------------------------------

HP_STATUS 1
HP_ARMOR 1
HP_DEATH 1
HP_DISPLAY 1
HP_WEAPON 1
HP_UDO 1

nderungen zu Vorgngern:
----------------------
- neue Waffenerkennung
- neue Vault.ini Werte
- verbesserter Code

Vorraussetzung:
----------------------
Korrekt installiertes Logd, mp_logdetail 3 und vorhandene Logs. (log on)
Damit die Logs nicht zu gro werden, ist es ratsam, logd_block 58 ebenfalls
in die (listen)server.cfg einzutragen.

Bei Problemen im www.adminmod.de Forum melden.

Viel Spass,

Sir D.
*/

#include <core> 
#include <console> 
#include <string> 
#include <admin> 
#include <adminlib> 

#define ACCESS_CONSOLE 131072 
#define CLEAN_SLATE 0

new STRING_VERSION[MAX_TEXT_LENGTH] = "4.0 (03.05.03)";

new hp_armor;
new hp_death;
new hp_display;
new hp_status;
new hp_udo;
new hp_weapon;


#define MAX_WEAPONS	24
new g_WeaponName[MAX_WEAPONS][MAX_NAME_LENGTH]	=	{{"usp"},{"glock18"},{"deagle"},{"mp5navy"},{"m4a1"},{"ak47"},{"awp"},{"aug"},{"sg552"},
							{"scout"},{"m249"},{"p90"},{"p228"},{"tmp"},{"mac10"},{"ump40"},{"fiveseven"},
							{"elite"},{"m3"},{"xm1014"},{"sg550"},{"g3sg1"},{"grenade"},{"knife"}};
new g_WeaponText[MAX_WEAPONS][MAX_TEXT_LENGTH]	=	{{"der H&K USP"},{"der Glock 18"},{"der Desert Eagle"},
							{"der MP5 Navy"},{"der M4A1"},{"der AK-47"},
							{"der AWP"},{"der Steyr Aug"},{"der Sig SG-552"},{"der Steyr Scout"},{"der FN M249 Para"},
							{"der FN P90"},{"der SIG P228"},{"der Steyr TMP"},{"der Ingram MAC-10"},
							{"der H&K UMP45"},{"der FN Five-Seven"},{"den Elite Dual Berettas"},
							{"der M3 Super90"},{"der XM1014"},{"der Sig SG-550 Sniper"},{"der H&K G3/SG-1"},
							{"der HE Granate"},{"dem Messer"}};

new AttackerArmor[MAX_PLAYERS]={100,...};
new AttackerHealth[MAX_PLAYERS]={100,...};
new AttackerName[MAX_PLAYERS];
new AttackerWeaponUsed[MAX_PLAYERS][MAX_TEXT_LENGTH];
new VictimHPDamage[MAX_PLAYERS][MAX_PLAYERS];
new VictimArmorDamage[MAX_PLAYERS][MAX_PLAYERS];

public admin_hp(HLCommand,HLData,HLUserName,UserIndex){
	new Data[MAX_TEXT_LENGTH];
	new Text[MAX_TEXT_LENGTH];
	new Command[MAX_TEXT_LENGTH];
	new VaultEntry[MAX_TEXT_LENGTH];

	new Mode[3];
	new iMode;
	
	convert_string(HLData,Data,MAX_TEXT_LENGTH);

	strbreak(Data,Command,Mode,MAX_TEXT_LENGTH);

	iMode=strtonum(Mode);
	if(streq(Command,"help")==1 || strlen(Command)==0){
		err(3,"");
		return PLUGIN_HANDLED;
	}
	if(strcmp(Mode,"0")==0 || strcmp(Mode,"1")==0){
		if(streq(Command,"armor")==1){
			strcpy(VaultEntry,"HP_ARMOR",MAX_TEXT_LENGTH);
			hp_armor=iMode;
		}else if(streq(Command,"death")==1){
			strcpy(VaultEntry,"HP_DEATH",MAX_TEXT_LENGTH);
			hp_death=iMode;
		}else if(streq(Command,"display")==1){
			strcpy(VaultEntry,"HP_DISPLAY",MAX_TEXT_LENGTH);
			hp_display=iMode+2;
		}else if(streq(Command,"status")==1){
			strcpy(VaultEntry,"HP_STATUS",MAX_TEXT_LENGTH);
			hp_status=iMode;
		}else if(streq(Command,"udo")==1){
			strcpy(VaultEntry,"HP_UDO",MAX_TEXT_LENGTH);
			hp_udo=iMode;
		}else if(streq(Command,"weapon")==1){
			strcpy(VaultEntry,"HP_WEAPON",MAX_TEXT_LENGTH);
			hp_weapon=iMode;
		}else{
			err(2,"");
			return PLUGIN_HANDLED;
		}
	}else if(strcmp(Mode,"2")==0){
		if(streq(Command,"display")==1){
			strcpy(VaultEntry,"HP_DISPLAY",MAX_TEXT_LENGTH);
			hp_display=iMode+2;
		}else{
			err(2,"");
			return PLUGIN_HANDLED;
		}
	}else{
		err(1,Command);
		return PLUGIN_HANDLED;
	}
	set_vaultdata(VaultEntry,Mode);
	snprintf(Text,MAX_TEXT_LENGTH,"%s is set to %s",VaultEntry,Mode);
	selfmessage(Text);
	return PLUGIN_HANDLED;
}
	
public hp_injure( HLCommand,HLData,HLUserName,UserIndex){	
	new Data[MAX_TEXT_LENGTH];
	new sIDA[3];
   	new sIDV[3];
	new Weapon[MAX_NAME_LENGTH];
	new Victim[MAX_NAME_LENGTH];
	new Attacker[MAX_NAME_LENGTH];
	
	new iIDA;
	new iIDV;
	new ihealth;
	new iarmor;
	
   	convert_string( HLData, Data, MAX_TEXT_LENGTH );
   	strsplit(Data," ",sIDA,MAX_NAME_LENGTH,sIDV,MAX_NAME_LENGTH,Weapon,MAX_NAME_LENGTH);
   	
	iIDA = strtonum(sIDA); 
   	iIDV = strtonum(sIDV);

	playerinfo(iIDA,Attacker,MAX_NAME_LENGTH); 
   	playerinfo(iIDV,Victim,MAX_NAME_LENGTH);

	get_userHealth(Victim, ihealth);
	get_userArmor(Victim, iarmor);
	if(iarmor==0){
		iarmor=100;
	}
	VictimHPDamage[iIDA][iIDV]=100-ihealth;
	VictimArmorDamage[iIDA][iIDV]=100-iarmor;
	
	return PLUGIN_CONTINUE;
}
	
	
public hp_kill( HLCommand,HLData,HLUserName,UserIndex){
	if(hp_status==1){
		new Data[MAX_TEXT_LENGTH];
	   	new Text[MAX_TEXT_LENGTH];
		new Weapon[MAX_NAME_LENGTH];
		new Victim[MAX_NAME_LENGTH];
	   	new Attacker[MAX_NAME_LENGTH];
	   	new sIDA[3];
	   	new sIDV[3];
	   	new Authid[MAX_AUTHID_LENGTH];
	   	new dummy;
		new iIDA;
		new iIDV;
		new iRand = random(3);
		new i;
		
		new Weap[MAX_TEXT_LENGTH];
		new Health[MAX_TEXT_LENGTH];
		new Udo[MAX_TEXT_LENGTH];
		new Armor[MAX_TEXT_LENGTH];
	
	   	convert_string( HLData, Data, MAX_TEXT_LENGTH ); 
	   	strsplit(Data," ",sIDA,MAX_NAME_LENGTH,sIDV,MAX_NAME_LENGTH,Weapon,MAX_NAME_LENGTH); 
	    	
		iIDA = strtonum(sIDA); 
	   	iIDV = strtonum(sIDV);
	
		playerinfo(iIDA,Attacker,MAX_NAME_LENGTH); 
	   	playerinfo(iIDV,Victim,MAX_NAME_LENGTH,dummy,dummy,dummy,dummy,Authid);

		AttackerName[iIDV]=iIDA;

		new ihealth;
		new iarmor;
		get_userHealth(Attacker, ihealth);
		get_userArmor(Attacker, iarmor);
		AttackerArmor[iIDV]=iarmor;
		AttackerHealth[iIDV]=ihealth;
		
		if(hp_death==1){
			if(hp_weapon==1){
				
				for(i=0;i<=MAX_WEAPONS;i++){
					if(strcmp(Weapon,g_WeaponName[i])==0){
						strcpy(AttackerWeaponUsed[iIDV],g_WeaponText[i],MAX_TEXT_LENGTH);
						snprintf(Weap,MAX_TEXT_LENGTH,"Er traf Dich mit %s.",AttackerWeaponUsed[iIDV][iIDV]);
						break;
					}
				}
			   	
			}
			if(ihealth>=100){
				switch(iRand){
					case 0: snprintf(Text,MAX_TEXT_LENGTH,"%s wurde von Niemandem verletzt!^n%s",Attacker,Weap);
					case 1: snprintf(Text,MAX_TEXT_LENGTH,"%s wurde von keiner Kugel getroffen!^n%s",Attacker,Weap);
					case 2: snprintf(Text,MAX_TEXT_LENGTH,"%s ist jeder Kugel ausgewichen!^n%s",Attacker,Weap);
				}
			}else if (ihealth <100){
				snprintf(Health,MAX_TEXT_LENGTH,"%i HP",ihealth);
				if(hp_armor==1){
					snprintf(Armor,MAX_TEXT_LENGTH,"und %i Armor.",iarmor);
				}
				if(hp_udo==1){
					if(VictimHPDamage[iIDV][iIDA]!=0){	
						snprintf(Udo,MAX_TEXT_LENGTH,"Du hast ihm %i HP und %i Armor abgezogen",VictimHPDamage[iIDV][iIDA],VictimArmorDamage[iIDV][iIDA]);
					}else{
						snprintf(Udo,MAX_TEXT_LENGTH,"Du hast ihn aber nicht getroffen :-(");
					}
				}
				snprintf(Text,MAX_TEXT_LENGTH,"%s hatte noch %s %s^n%s^n%s",Attacker,Health,Armor,Weap,Udo);
			}
			if(strcmp(Authid,"BOT")!=0){
				messageex(Victim,Text,hp_display);
			}
		}
	}
	return PLUGIN_HANDLED;
}
public hp_reset(HLCommand,HLData,HLUserName,UserIndex){
	if(hp_status==1){
	   	new loop;
		new i;
	   	new Data[MAX_NAME_LENGTH];
	   	convert_string(HLData,Data,MAX_NAME_LENGTH); 
	    
	   	if(strcmp("Round_Start", Data)!= 0){
	      		return PLUGIN_HANDLED;
	      	}
	   	for(loop=0;loop<MAX_PLAYERS;loop++){
			AttackerArmor[loop]=100;
			AttackerHealth[loop]=100;
			AttackerName[loop]=CLEAN_SLATE;
			for(i=0;i<MAX_PLAYERS;i++){
				AttackerWeaponUsed[loop][i]=CLEAN_SLATE;
				VictimHPDamage[loop][i]=CLEAN_SLATE;
				VictimArmorDamage[loop][i]=CLEAN_SLATE;
			}
	   	}
	}
   	return PLUGIN_HANDLED; 
}

public HandleSay(HLCommand,HLData,HLUserName,UserIndex){
	if(hp_status==1){
		new Data[MAX_TEXT_LENGTH];
		new User[MAX_TEXT_LENGTH];
		new WONID;
		new Text[MAX_TEXT_LENGTH];
		new Weapon[MAX_NAME_LENGTH];
		new Armor[MAX_TEXT_LENGTH];
		new Udo[MAX_TEXT_LENGTH];
		new Health[MAX_TEXT_LENGTH];
		new Attacker[MAX_NAME_LENGTH];
		
		new IsDead = 0,UserID,Team;
		new iRand = random(3);

		convert_string(HLData,Data,MAX_TEXT_LENGTH); 
	   	convert_string(HLUserName,User,MAX_TEXT_LENGTH); 
	   	strstripquotes(Data);
				
		if (streq(Data, "hp?")==1 || streq(Data, "hp")==1 || streq(Data, "hp ?")==1 ||streq(Data, "?hp")==1){
	      		playerinfo(UserIndex,User,MAX_TEXT_LENGTH,UserID,WONID,Team,IsDead); 
	      		if(IsDead == 0){ 
	         		return PLUGIN_CONTINUE; 
	      		}else{
	      			if(AttackerName[UserIndex]==0){
					messageex(User,"Du wurdest von keinem umgebracht. Selbstmord? ^nOder war es der boese Admin?",hp_display);
	      				return PLUGIN_CONTINUE;
	      			}
				playerinfo(AttackerName[UserIndex],Attacker,MAX_NAME_LENGTH);
				if(AttackerHealth[UserIndex]==100){
					switch(iRand){
						case 0: snprintf(Text,MAX_TEXT_LENGTH,"%s wurde von Niemandem verletzt!^nEr traf Dich mit %s",Attacker,AttackerWeaponUsed[UserIndex][UserIndex]);
						case 1: snprintf(Text,MAX_TEXT_LENGTH,"%s wurde von keiner Kugel getroffen!^nEr traf Dich mit %s",Attacker,AttackerWeaponUsed[UserIndex][UserIndex]);
						case 2: snprintf(Text,MAX_TEXT_LENGTH,"%s ist jeder Kugel ausgewichen!^nEr traf Dich mit %s",Attacker,AttackerWeaponUsed[UserIndex][UserIndex]);
					}
					messageex(User,Text,hp_display);
					return PLUGIN_CONTINUE;
				}else{
					snprintf(Health,MAX_TEXT_LENGTH,"%i HP",AttackerHealth[UserIndex]);
					if(hp_armor==1){
						snprintf(Armor,MAX_TEXT_LENGTH,"und %i Armor.",AttackerArmor[UserIndex]);
					}
					if(hp_weapon==1){
						snprintf(Weapon,MAX_TEXT_LENGTH,"Er traf Dich mit %s.",AttackerWeaponUsed[UserIndex][UserIndex]);
					}
					if(hp_udo==1){
						if(VictimHPDamage[UserIndex][AttackerName[UserIndex]]!=0){
							snprintf(Udo,MAX_TEXT_LENGTH,"Du hast ihm %i HP und %i Armor abgezogen.",VictimHPDamage[UserIndex][AttackerName[UserIndex]],VictimArmorDamage[UserIndex][AttackerName[UserIndex]]);
						}else{
							snprintf(Udo,MAX_TEXT_LENGTH,"Du hast ihn aber nicht getroffen :-(");
						}
					}
					snprintf(Text,MAX_TEXT_LENGTH,"%s hatte noch %s %s^n%s^n%s",Attacker,Health,Armor,Weapon,Udo);
					messageex(User,Text,hp_display);
				}
			}
		}
	}
	return PLUGIN_CONTINUE;
}

public err(a,Command[]){
	new Text[MAX_TEXT_LENGTH];
	new VaultEntry[MAX_TEXT_LENGTH];

	if (a==1){
		snprintf(Text,MAX_TEXT_LENGTH,"msg HP: mode can only be set to 0, 1 oder 2(for display)");
		selfmessage(Text);
	}else if (a==2){
		snprintf(Text,MAX_TEXT_LENGTH,"msg HP: command %s is not valid",Command);
		selfmessage(Text);
	}else if (a==3){
		selfmessage("--- PLUGIN-HP-Help ---");
		selfmessage("These values are set in vault.ini:");
		get_vaultdata("HP_STATUS",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_STATUS is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("HP_ARMOR",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_ARMOR is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("HP_DEATH",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_DEATH is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("HP_DISPLAY",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_DISPLAY is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("HP_UDO",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_UDO is set to %s",VaultEntry);
		selfmessage(Text);
		get_vaultdata("HP_WEAPON",VaultEntry,MAX_TEXT_LENGTH);
		snprintf(Text,MAX_TEXT_LENGTH,"HP_WEAPON is set to %s",VaultEntry);
		selfmessage(Text);
		selfmessage("");
		selfmessage("To change these values, use following commands:");
		selfmessage("admin_hp <COMMAND> <MODE>");
		selfmessage("admin_hp status 1/0-->turns HP-Plugin on/off");
		selfmessage("admin_hp armor 1/0-->turns display of armor on/off");
		selfmessage("admin_hp death 1/0-->0=only shows HP in chat by typing hp/?hp/hp?,1=shows HP directly after death");
		selfmessage("admin_hp display 1/2/0-->0=display in chat-area,1=display as tsay,2=display as csay");
		selfmessage("admin_hp udo 1/0-->turns display of damage on/off, which you add to your enemy");
		selfmessage("admin_hp weapon 1/0-->turns display of weapon on/off");
		selfmessage("");
	}
	return PLUGIN_HANDLED;
}
		
public plugin_init(){ 
	plugin_registerinfo("?HP?-Script","Announces the health of your opponent, who kills you",STRING_VERSION); 
	plugin_registercmd("hp_kill", "hp_kill", ACCESS_CONSOLE, "");
	plugin_registercmd("hp_reset", "hp_reset", ACCESS_CONSOLE, "");
	plugin_registercmd("hp_injure", "hp_injure", ACCESS_CONSOLE, ""); 
	plugin_registercmd("admin_hp", "admin_hp", ACCESS_BAN, "admin_hp <Command> <mode>: configurates this hp-plugin.Use admin_hp help!");
	plugin_registercmd("say","HandleSay",ACCESS_ALL); 
	plugin_registerhelp("say",ACCESS_ALL,"say hp?/hp/hp ?/?hp: Will announce the health and weapon of your killer."); 
	exec( "logd_reg 57 admin_command hp_kill" );
	exec( "logd_reg 58 admin_command hp_injure" ); 
	exec( "logd_reg 62 admin_command hp_reset" );  
	
	get_vaultnumdata("HP_STATUS",hp_status);
	get_vaultnumdata("HP_ARMOR",hp_armor);
	get_vaultnumdata("HP_DEATH",hp_death);
	get_vaultnumdata("HP_DISPLAY",hp_display);
	hp_display+=2;
	get_vaultnumdata("HP_UDO",hp_udo);
	get_vaultnumdata("HP_WEAPON",hp_weapon);
	
	return PLUGIN_CONTINUE; 
}
